
class DigitalPin {
    private int pinNumber;
    public int x, y;
    public int mode = -1;
    public int digitalSignal = Arduino.LOW;
    public int pwmSignal = 0;
    public boolean isPWM = false;
    public boolean shouldWrite = false;

    public DigitalPin(int pinNumber) {
        this.pinNumber = pinNumber;
    }

    public void click() {
        shouldWrite = true;
        if (mode == OUTPUT_MODE) {
            digitalSignal = (digitalSignal == Arduino.LOW ? Arduino.HIGH : Arduino.LOW);
        }
    }

    public void setMode(int mode) {
        if (this.mode == mode) {
            return;
        }
        this.mode = mode;
        if (mode == OUTPUT_MODE) {
            digitalSignal = Arduino.LOW;
        }
        if ((mode == OUTPUT_MODE) || (mode == PWM_MODE)) {
            if (arduino != null) {
                arduino.pinMode(pinNumber, Arduino.OUTPUT);
            }
        }
        if ((mode == INPUT_MODE) || (mode == INPUT_PULLUP_MODE)) {
            if (arduino != null) {
                arduino.pinMode(pinNumber, Arduino.INPUT);
                if (mode == INPUT_PULLUP_MODE) {
		    arduino.digitalWrite(pinNumber, Arduino.HIGH);
                } else {
		    arduino.digitalWrite(pinNumber, Arduino.LOW);
                }
            }
        }
    }
    public void setPWMSignal(int s) {
        shouldWrite = true;
        pwmSignal = s;
    }
}
